// Generated by CoffeeScript 1.2.1-pre
(function() {
  var Action, Actions, Array, Arrays, Environment, FS, Function, FunctionByLengthMap, FunctionByTypesPairs, FunctionTemplate, Keys, Map, Number, Object, Optional, Pair, Pairs, Path, RegExp, Set, SortedArray, String, Strings, Text, cleanDir, containerDir, copy, copyDir, copyFile, copyInto, correct, createDir, deepPaths, deepPathsWithExtension, dir, dirExists, dirs, exists, extension, fileContents, fileExists, fileName, isAbsolute, name, normalized, parts, paths, relative, relativeTo, remove, removeDir, removeDirContents, removeFile, saveFile, simplified, targetPath, withSlash, withoutExtension, withoutSlash, _ref;

  _ref = require("Fuell"), Action = _ref.Action, Actions = _ref.Actions, Array = _ref.Array, Arrays = _ref.Arrays, Environment = _ref.Environment, Function = _ref.Function, FunctionByLengthMap = _ref.FunctionByLengthMap, FunctionByTypesPairs = _ref.FunctionByTypesPairs, FunctionTemplate = _ref.FunctionTemplate, Keys = _ref.Keys, Map = _ref.Map, Number = _ref.Number, Object = _ref.Object, Optional = _ref.Optional, Pair = _ref.Pair, Pairs = _ref.Pairs, RegExp = _ref.RegExp, Set = _ref.Set, SortedArray = _ref.SortedArray, String = _ref.String, Strings = _ref.Strings, Text = _ref.Text;

  FS = require("fs");

  Path = require("path");

  exports.isAbsolute = isAbsolute = function(p) {
    throw "Unimplemented: Path.isAbsolute";
  };

  exports.normalized = normalized = function(p) {
    return simplified(correct(p));
  };

  exports.correct = correct = function(p) {
    return String.replacing(/^\.\/|^\.$/, "", String.replacing(/\/+/g, "/", p));
  };

  exports.withoutExtension = withoutExtension = function(p) {
    return Strings.interlayedUnion("", Array.allButLast(parts(p)));
  };

  exports.extension = extension = function(p) {
    return Array.member(2, parts(p));
  };

  exports.fileName = fileName = function(p) {
    return Array.member(1, parts(p));
  };

  exports.name = name = function(p) {
    return Strings.interlayedUnion(".", Array.results(Object.self, Array.dropping(1, parts(p))));
  };

  exports.dir = dir = function(p) {
    return Array.member(0, parts(p));
  };

  exports.parts = parts = function(p) {
    return String.extracts(/^(.*?\/)?([^\/]+?)?(?:\.([^\/\.]*))?$/, p);
  };

  exports.relative = relative = function(to, from) {
    /*
      deprecated in favor of `relativeTo`
    */
    to = String.splitBy("/", simplified(correct(to)));
    from = Array.allButLast(String.splitBy("/", simplified(correct(from))));
    if ((to[0] === "") !== (from[0] === "")) {
      throw "Either both paths must be absolute or none";
    }
    while ((to[0] != null) && to[0] === from[0]) {
      to.shift();
      from.shift();
    }
    return Strings.interlayedUnion("/", Array.union(to, Number.times("..", Array.length(from))));
  };

  exports.from = exports.relativeTo = relativeTo = function(target, path) {
    return relative(path, target);
  };

  exports.simplified = simplified = function(p) {
    var debt, it, r, _i, _len, _ref1;
    p = String.splitBy("/", p);
    r = [];
    debt = 0;
    _ref1 = Array.reversed(p);
    for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
      it = _ref1[_i];
      if (it === "..") {
        debt++;
      } else if (debt > 0) {
        debt--;
      } else {
        r.push(it);
      }
    }
    if (debt > 0) r = Array.union(Number.times("..", debt), r);
    return Strings.interlayedUnion("/", Array.reversed(r));
  };

  exports.exists = exists = Path.existsSync;

  exports.remove = remove = function(p, cb) {
    if (!exists(p)) {
      return cb();
    } else {
      if (FS.statSync(p).isFile()) {
        return FS.unlink(p, cb);
      } else {
        return Array.collect(remove, paths(p), function() {
          return FS.rmdir(p, cb);
        });
      }
    }
  };

  exports.fileExists = fileExists = function(p) {
    var _ref1, _ref2;
    return (_ref1 = (_ref2 = ((function() {
      try {
        return FS.statSync(p);
      } catch (_error) {}
    })())) != null ? _ref2.isFile() : void 0) != null ? _ref1 : false;
  };

  exports.dirExists = dirExists = function(p) {
    var _ref1, _ref2;
    return (_ref1 = (_ref2 = ((function() {
      try {
        return FS.statSync(p);
      } catch (_error) {}
    })())) != null ? _ref2.isDirectory() : void 0) != null ? _ref1 : false;
  };

  exports.copy = copy = function(target, src, cb) {
    if (dirExists(src)) {
      return copyDir(target, src, cb);
    } else if (fileExists(src)) {
      return copyFile(target, src, cb);
    } else {
      throw "Path.copy: Path doesn't exist";
    }
  };

  exports.copyInto = copyInto = function(targetDir, src, cb) {
    return copy(String.prepending(targetDir + "/", name(src)), src, cb);
  };

  exports.copyFile = copyFile = function(target, src, cb) {
    return createDir(dir(target), function() {
      return FS.writeFile(target, FS.readFileSync(src), cb);
    });
  };

  exports.copyDir = copyDir = function(target, src, cb) {
    return createDir(target, function() {
      return Array.each(function(p, cb) {
        return (dirExists(p) ? copyDir : copyFile)(target + "/" + (name(p)), p, cb);
      }, paths(src), cb);
    });
  };

  exports.deepPaths = deepPaths = function(p) {
    var ps;
    if (dirExists(p)) {
      ps = paths(p);
      return Arrays.union(Array.appendedWith(ps, Array.results(deepPaths, ps)));
    }
  };

  exports.deepPathsWithExtension = deepPathsWithExtension = function(extension, dir) {
    return Optional.result([Array.matches, [[Object.equals, extension], Path.extension]], deepPaths(dir));
  };

  exports.paths = paths = function(p) {
    var sp, _i, _len, _ref1, _results;
    _ref1 = FS.readdirSync(p);
    _results = [];
    for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
      sp = _ref1[_i];
      _results.push(p + "/" + sp);
    }
    return _results;
  };

  exports.dirs = dirs = function(p) {
    var name, p1, _i, _len, _ref1, _results;
    _ref1 = FS.readdirSync(p);
    _results = [];
    for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
      name = _ref1[_i];
      if (exists(p1 = p + "/" + name)) _results.push(p1);
    }
    return _results;
  };

  exports.withoutSlash = withoutSlash = function(p) {
    return String.replacing(/\/+$/, "", p);
  };

  exports.withSlash = withSlash = function(p) {
    var p1;
    p1 = withoutSlash(p);
    if (p1 !== "") return p1 + "/";
  };

  targetPath = function(targetDir, dir, path) {
    return String.prepending(withSlash(targetDir), relativeTo(dir, path));
  };

  exports.containerDir = containerDir = function(path) {
    return dir(withoutSlash(path));
  };

  exports.createDir = createDir = function(path, cb) {
    var dir1;
    if (path) {
      dir1 = containerDir(path);
      if (dirExists(dir1)) {
        return FS.mkdir(path, "0777", cb);
      } else {
        return createDir(dir1, function() {
          return FS.mkdir(path, "0777", cb);
        });
      }
    } else {
      return cb();
    }
  };

  exports.removeDirContents = removeDirContents = function(dir, cb) {
    var files, _ref1;
    _ref1 = Array.spread(dirExists, paths(dir)), dirs = _ref1[0], files = _ref1[1];
    return Actions.callParallelly(Arrays.union([
      Array.results((function(file) {
        return function(cb) {
          return removeFile(file, cb);
        };
      }), files), Array.results((function(dir) {
        return function(cb) {
          return removeDir(dir, cb);
        };
      }), dirs)
    ]), cb);
  };

  exports.remove = remove = function(path, cb) {
    if (dirExists(path)) {
      return removeDir(path, cb);
    } else if (fileExists(path)) {
      return removeFile(path, cb);
    } else {
      return cb;
    }
  };

  exports.removeDir = removeDir = function(dir, cb) {
    if (dirExists(dir)) {
      return removeDirContents(dir, function() {
        return FS.rmdir(dir, cb);
      });
    }
  };

  exports.removeFile = removeFile = FS.unlink;

  exports.cleanDir = cleanDir = function(dir, cb) {
    if (dirExists(dir)) {
      return removeDirContents(dir, cb);
    } else {
      return create(dir, cb);
    }
  };

  exports.saveFile = saveFile = function(data, file, cb) {
    return createDir(dir(file), function() {
      return FS.writeFile(file, data, "utf8", cb);
    });
  };

  exports.fileContents = fileContents = function(f) {
    try {
      return FS.readFileSync(f, "utf8");
    } catch (_error) {}
  };

}).call(this);
